﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Text.RegularExpressions;


namespace nanikoreKun
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            drawMasu();

        }
////////////////////////////////////////////////////////////////////////////////

        //マスをパネルに配置する
        private void drawMasu()
        {
            //マスを配置します。
            int j= 0;
            int k = 0;
            for (int i = 1; i <= 81; i++)
            {
                Label sujilabel = new Label();
                TextBox atextbox = new TextBox();
                atextbox.AutoSize = false;
                atextbox.Margin = new System.Windows.Forms.Padding(0);
                atextbox.Location = new System.Drawing.Point(10+j,10+ k);

                atextbox.MaximumSize = new System.Drawing.Size(35, 42);
                atextbox.MinimumSize = new System.Drawing.Size(35, 42);
                atextbox.Name = "マス" + i.ToString(); ;
                atextbox.Size = new System.Drawing.Size(35, 42);
                atextbox.Multiline = true;
                //atextbox.Text = "1 2 3 4 5 6 7 8 9 ";
                atextbox.BorderStyle = System.Windows.Forms.BorderStyle.None;

                atextbox.BackColor = System.Drawing.Color.White;
                atextbox.ForeColor = System.Drawing.Color.Black;
                atextbox.Font = new System.Drawing.Font("MS UI Gothic", 23.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
                atextbox.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
                atextbox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBox1_KeyDown);
                atextbox.DoubleClick += new System.EventHandler(this.textBox1_DoubleClick);
                this.panel1.Controls.Add(atextbox);
                

                j += 39;

                if (i % 3 == 0) { j += 5; }
                if (i % 9 == 0) { k += 46; j = 0; }
                if (i % 27 == 0) { k += 5; }

            }
            listBox1.Items.Clear();
           
        }


        //テキストボックスでエンターが押されたらマスの外縁の色を変える。
        //エスケープなら元に戻す。
        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            //マスに入力後、ENTERキーが押されると問題マスのにします。
            TextBox t = new TextBox();
            t = (TextBox)sender;
            if (e.KeyCode == Keys.Enter)
            {
                t.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
                t.ForeColor = System.Drawing.Color.BlueViolet;

            }
            if (e.KeyCode == Keys.Escape)//エスケープキーで編集可能に
            {
                //t.Text = "1 2 3 4 5 6 7 8 9 ";
                t.BorderStyle = System.Windows.Forms.BorderStyle.None;

                t.BackColor = System.Drawing.Color.White;
                t.ForeColor = System.Drawing.Color.Black;

            }


        }

        //テキストボックスがダブルクリックされると、編集可能に
        private void textBox1_DoubleClick(object sender, EventArgs e)
        {
            TextBox t = new TextBox();
            t = (TextBox)sender;
            t.ReadOnly = false;
            t.BorderStyle = System.Windows.Forms.BorderStyle.None;

            t.BackColor = System.Drawing.Color.White;
            t.ForeColor = System.Drawing.Color.Black;
            t.Font = new System.Drawing.Font("MS UI Gothic", 23.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
        }


        //マスをすべて起動時の状態にする。『初期化』ボタン
        private void button2_Click(object sender, EventArgs e)
        {
            breaker = false;


            panel1.Controls.Clear();
            drawMasu();
            count2 = countKakuteiSuu = countK=0;
            countnewKakutei = 1;
            label7.Text = "";
            listBox1.Items.Clear();
        }

        //問題（外縁があり）のマス以外を初期状態にする。『やり直し』ボタン
        private void button3_Click(object sender, EventArgs e)
        {

            breaker = false;
            count2 = 0;
            countK=0;
            countnewKakutei = 1;
            listBox1.Items.Clear();
            label7.Text = "";
            foreach (TextBox t in panel1.Controls)
            {
                t.ReadOnly = false;
                if (t.BorderStyle == System.Windows.Forms.BorderStyle.None)
                {

                    t.BorderStyle = System.Windows.Forms.BorderStyle.None;
                    t.Text = "";
                    t.BackColor = System.Drawing.Color.White;
                    t.ForeColor = System.Drawing.Color.Black;
                    t.Font = new System.Drawing.Font("MS UI Gothic", 23.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));

                }
            }

        }

        //問題のマス以外を初期状態にする。候補０～９を配置
        private void reSet()
        {

            breaker = false;
            
            countnewKakutei = 1;

            label7.Text = "";
            foreach (TextBox t in panel1.Controls)
            {
                t.ReadOnly = false;

                if (t.BorderStyle == System.Windows.Forms.BorderStyle.None)
                {
  
                    t.BorderStyle = System.Windows.Forms.BorderStyle.None;
                    t.Text = "1 2 3 4 5 6 7 8 9 ";
                    t.BackColor = System.Drawing.Color.White;
                    t.ForeColor = System.Drawing.Color.Black;
                    t.Font = new System.Drawing.Font("MS UI Gothic", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));

                }
            }

        }

////////////////////////////////////////////////////////////////////////////////

        private static int countnewKakutei = 1;//新しい確定マスが出来たら加算
        private static int count2 = 0;//ループの回数カウンタ
        private static int countKakuteiSuu = 0;//確定マスの数
        private static string[] kariokimem = new string[81];　//仮置きの記憶　
        private static int A = 0; //仮置き階層
        private static bool breaker = false;//解の候補が０になるとtrueに、ループから抜ける。
        private static int countK = 0;//仮置きの回数カウンタ




        //実行ボタンが押されたら実行　メイン処理
        private void button1_Click(object sender, EventArgs e)
        {
            //入力された問題が一桁の数値かチェック
            int chkt = 0;
            int ts=0;
            bool flg =false;
            foreach (TextBox t in panel1.Controls)
            {
                Regex regexSP = new System.Text.RegularExpressions.Regex(" ");
                t.ReadOnly = false;
                if (t.Text != "")
                {
                    try
                    {
                        ts=int.Parse(regexSP.Replace(t.Text, ""));

                        if (ts > 0 && ts < 10) { flg = true; } else { flg = false; break; }

                    }catch{
                        flg = false; break;
                    }

                    chkt = chkt + 1;
                    //問題マスの色に変更
                    t.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
                    t.ForeColor = System.Drawing.Color.BlueViolet;
                    t.BackColor = Color.Gray;
                    t.Text = regexSP.Replace(t.Text, "");
                    t.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
                    t.Font = new System.Drawing.Font("MS UI Gothic", 23.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
                    t.ForeColor = System.Drawing.Color.Aquamarine;
                    t.ReadOnly = true;


                }
            }
            //入力に問題がなかったら解答を求める
            if (chkt != 0 && flg == true && chkt!=81)
            {

                reSet();//マスに候補１～９を再配置

                //仮置きの記憶を初期化
                for (int i = 0; i < kariokimem.Length; i++)
                {
                    if (kariokimem[i] != null) { kariokimem[i] = null; }
                }
                A = 0; //仮置き階層を０に

                delNumLoop();　//解答のループを呼び出し。


                if (breaker) MessageBox.Show("失敗");
                string level = "";

                if (count2 + (countK * 10) < 8)
                {
                    level = "初級"; 
                }
                else if (count2 + (countK * 10) < 12)
                {
                    level="中級";
                }else
                {
                    level="上級";
                }


                label7.Text = ("ループ：" + count2 + "回" + " 仮置き数：" + countK + "回"+" レベル判定："+level);

            }
            else { MessageBox.Show("入力間違いがあります。修正が必要です。\n初期化ボタンで全て入力をやり直す。\n（固定されたマスはダブルクリックで修正できます。）"); }
        }

        //解答のメインループ
        private void delNumLoop()
        {
            delnum();//確定判定と候補の削除

            karioki();//仮置きを実施

         }

        //仮置き
        private void karioki()
        {
            if (countKakuteiSuu == 81) { return; }//すべて確定していたら終わり
            countK++;
            listBox1.Items.Add("★仮置き：" + countK+"回 階層：" + A);
            if (checkBox1.Checked) MessageBox.Show("仮置き処理を実施 階層：" + A);

            //候補の値が最小のマスを求め、仮置きするマスと値を決定
            int keta = 0;
            int tmp = 123456789;
            string aName = "";//仮置きするマスの名前
            foreach (TextBox te in this.panel1.Controls)
            {
                try
                {
                    Regex regexSP = new System.Text.RegularExpressions.Regex(" ");

                    if (te.ReadOnly != true)
                    {
                        int temp = int.Parse(regexSP.Replace(te.Text, ""));
                        if (temp < tmp)
                        {
                            aName = te.Name;
                            tmp = temp;
                        }

                    }
                }
                catch
                {
                    breaker = true; break;
                }

            }
            listBox1.Items.Add("対象：" + aName + "　候補:" + tmp);
            TextBox atextbox = new TextBox();

            keta = tmp.ToString().Length;
            String[] a = new String[keta];
            for (int i = 0; i < a.Length; ++i)
            {
              a[i] = tmp.ToString().Substring(i, 1);//仮置きする値の配列
            }
   
            //仮置きするマスに残っている候補を順に仮置き
            foreach (String s in a)
            {
                if (countKakuteiSuu == 81) { return; }//すべて確定していたら終わり

                kariokimem[A] = aName + "," + s + "," + A;　//仮置きの記憶に登録　 aName：マスの名前 s:仮置きした数値 A:階層　

                if (breaker != true && countKakuteiSuu != 81) 
                {
                    foreach (string str in kariokimem) //仮置き記憶から順にマスに仮置き
                    {
                          if (str != null)
                            {
                                 string[] fild = new string[3];
                                 fild = str.Split(',');

                                 foreach (TextBox textboxa in panel1.Controls.Find(fild[0], true))
                                      {
                                          atextbox = textboxa;
                                      }

                                atextbox.Text = fild[1];
                               if (checkBox1.Checked) MessageBox.Show("セット："+atextbox.Name + "　値:" + atextbox.Text+ "　階層："+ A);
                               listBox1.Items.Add(fild[2]+"："+fild[0] + " 値:" + fild[1]);
                             }
                    }

                    countnewKakutei = 1;
                    delnum();//確定判定と候補の削除

                    if (countKakuteiSuu == 81) { return; }//すべて確定していたら終わり

                    if (breaker == true)//解が求まらなかったら
                    {
                        if (checkBox1.Checked) MessageBox.Show("☆仮置き失敗☆");
                        listBox1.Items.Add("★仮置き失敗★");
                        reSet();//マスに候補１～９を再配置
                    }
                    else
                    {

                        A = A + 1; //階層を一段追加
                        listBox1.Items.Add("※階層追加：" + A);
                          karioki();　//仮置き実施　再帰

                    }
                }
               
            }
            if (countKakuteiSuu == 81) { return; }//すべて確定していたら終わり
            //今の階層以上の記憶をクリア
            for(int i =A;i < kariokimem.Length;i++)
            {
                if (kariokimem[i] != null) {  kariokimem[i] = null; }
            }

            A = A - 1;//階層をひとつ前に設定
            listBox1.Items.Add("※階層減少：" + A);
            if (checkBox1.Checked) MessageBox.Show("仮置き階層を一つ前まで戻り次の値を試します。");


        }


        private void delnum()
        {


            while (countnewKakutei != 0 && breaker != true)
            {
                count2++;
                label7.Text = ("ループ：" + count2 + "回。");


                countnewKakutei = 0;
                countKakuteiSuu = 0;
                unique();
                foreach (TextBox te in this.panel1.Controls)
                {

                    Regex regexSP = new System.Text.RegularExpressions.Regex(" ");

                    if (te.ReadOnly != true)
                    {
                        try
                        {


                            int temp = int.Parse(regexSP.Replace(te.Text, ""));

                            if (temp < 10 )
                            {
                                te.BackColor = Color.Gray;
                                te.Text = regexSP.Replace(te.Text, "");
                                te.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
                                te.Font = new System.Drawing.Font("MS UI Gothic", 23.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
                                te.ForeColor = System.Drawing.Color.Aquamarine;
                                te.ReadOnly = true;

                            }
                            if (te.ReadOnly == true)
                            {
                                countnewKakutei++;

                                if (checkBox1.Checked) MessageBox.Show("確定マスの数字を行　列　枠　から除去");

                                delnumTateYokoWaku(te.Name, te.Text);


                            }

                        }
                        catch { breaker = true; }
                    }
                    else
                    {

                        countKakuteiSuu++;

                    }

                }
                if (countKakuteiSuu == 81) { break; }
            }
        }



        //行　列　枠　でユニークな値を求める。
        private void unique()
        {
            if (checkBox1.Checked) MessageBox.Show("行　列　枠　でユニークな値を確定とする。");
            string[] textarYo1 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarYo2 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarYo3 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarYo4 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarYo5 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarYo6 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarYo7 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarYo8 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarYo9 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarTa1 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarTa2 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarTa3 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarTa4 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarTa5 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarTa6 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarTa7 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarTa8 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarTa9 = new string[9] { "", "", "", "", "", "", "", "", "" };


            string[] textarMa1 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarMa2 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarMa3 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarMa4 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarMa5 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarMa6 = new string[9] { "", "", "", "", "", "", "", "", "" };

            string[] textarMa7 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarMa8 = new string[9] { "", "", "", "", "", "", "", "", "" };
            string[] textarMa9 = new string[9] { "", "", "", "", "", "", "", "", "" };

            foreach (TextBox te in this.panel1.Controls)
            {


                if (te.ReadOnly != true)
                {
                    ////////////////////////縦

                    if (
                        te.Name == "マス1" || te.Name == "マス2" || te.Name == "マス3" ||
                        te.Name == "マス4" || te.Name == "マス5" || te.Name == "マス6" ||
                        te.Name == "マス7" || te.Name == "マス8" || te.Name == "マス9"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo1[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo1[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo1[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo1[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo1[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo1[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo1[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo1[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo1[8] += te.Name + "\t"; }
                    }

                    if (
                        te.Name == "マス10" || te.Name == "マス11" || te.Name == "マス12" ||
                        te.Name == "マス13" || te.Name == "マス14" || te.Name == "マス15" ||
                        te.Name == "マス16" || te.Name == "マス17" || te.Name == "マス18"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo2[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo2[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo2[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo2[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo2[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo2[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo2[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo2[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo2[8] += te.Name + "\t"; }
                    }

                    if (
                        te.Name == "マス19" || te.Name == "マス20" || te.Name == "マス21" ||
                        te.Name == "マス22" || te.Name == "マス23" || te.Name == "マス24" ||
                        te.Name == "マス25" || te.Name == "マス26" || te.Name == "マス27"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo3[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo3[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo3[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo3[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo3[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo3[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo3[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo3[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo3[8] += te.Name + "\t"; }
                    }

                    if (
                        te.Name == "マス28" || te.Name == "マス29" || te.Name == "マス30" ||
                        te.Name == "マス31" || te.Name == "マス32" || te.Name == "マス33" ||
                        te.Name == "マス34" || te.Name == "マス35" || te.Name == "マス36"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo4[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo4[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo4[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo4[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo4[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo4[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo4[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo4[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo4[8] += te.Name + "\t"; }
                    }

                    if (
                       te.Name == "マス37" || te.Name == "マス38" || te.Name == "マス39" ||
                       te.Name == "マス40" || te.Name == "マス41" || te.Name == "マス42" ||
                       te.Name == "マス43" || te.Name == "マス44" || te.Name == "マス45"
                       )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo5[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo5[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo5[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo5[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo5[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo5[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo5[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo5[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo5[8] += te.Name + "\t"; }
                    }

                    if (
                       te.Name == "マス46" || te.Name == "マス47" || te.Name == "マス48" ||
                       te.Name == "マス49" || te.Name == "マス50" || te.Name == "マス51" ||
                       te.Name == "マス52" || te.Name == "マス53" || te.Name == "マス54"
                       )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo6[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo6[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo6[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo6[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo6[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo6[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo6[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo6[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo6[8] += te.Name + "\t"; }
                    }

                    if (
                        te.Name == "マス55" || te.Name == "マス56" || te.Name == "マス57" ||
                        te.Name == "マス58" || te.Name == "マス59" || te.Name == "マス60" ||
                        te.Name == "マス61" || te.Name == "マス62" || te.Name == "マス63"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo7[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo7[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo7[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo7[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo7[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo7[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo7[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo7[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo7[8] += te.Name + "\t"; }
                    }
                    if (
                        te.Name == "マス64" || te.Name == "マス65" || te.Name == "マス66" ||
                        te.Name == "マス67" || te.Name == "マス68" || te.Name == "マス69" ||
                        te.Name == "マス70" || te.Name == "マス71" || te.Name == "マス72"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo8[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo8[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo8[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo8[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo8[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo8[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo8[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo8[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo8[8] += te.Name + "\t"; }
                    }
                    if (
                        te.Name == "マス73" || te.Name == "マス74" || te.Name == "マス75" ||
                        te.Name == "マス76" || te.Name == "マス77" || te.Name == "マス78" ||
                        te.Name == "マス79" || te.Name == "マス80" || te.Name == "マス81"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarYo9[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarYo9[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarYo9[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarYo9[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarYo9[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarYo9[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarYo9[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarYo9[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarYo9[8] += te.Name + "\t"; }
                    }






                    ////////////////////////縦

                    if (
                        te.Name == "マス1" || te.Name == "マス10" || te.Name == "マス19" ||
                        te.Name == "マス28" || te.Name == "マス37" || te.Name == "マス46" ||
                        te.Name == "マス55" || te.Name == "マス64" || te.Name == "マス73"
                        )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa1[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa1[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa1[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa1[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa1[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa1[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa1[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa1[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa1[8] += te.Name + "\t"; }
                    }

                    if (
                       te.Name == "マス2" || te.Name == "マス11" || te.Name == "マス20" ||
                       te.Name == "マス29" || te.Name == "マス38" || te.Name == "マス47" ||
                       te.Name == "マス56" || te.Name == "マス65" || te.Name == "マス74"
                       )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa2[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa2[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa2[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa2[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa2[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa2[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa2[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa2[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa2[8] += te.Name + "\t"; }
                    }
                    if (
                      te.Name == "マス3" || te.Name == "マス12" || te.Name == "マス21" ||
                      te.Name == "マス30" || te.Name == "マス39" || te.Name == "マス48" ||
                      te.Name == "マス57" || te.Name == "マス66" || te.Name == "マス75"
                      )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa3[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa3[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa3[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa3[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa3[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa3[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa3[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa3[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa3[8] += te.Name + "\t"; }
                    }
                    if (
                      te.Name == "マス4" || te.Name == "マス13" || te.Name == "マス22" ||
                      te.Name == "マス31" || te.Name == "マス40" || te.Name == "マス49" ||
                      te.Name == "マス58" || te.Name == "マス67" || te.Name == "マス76"
                      )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa4[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa4[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa4[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa4[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa4[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa4[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa4[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa4[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa4[8] += te.Name + "\t"; }
                    }
                    if (
                       te.Name == "マス5" || te.Name == "マス14" || te.Name == "マス23" ||
                       te.Name == "マス32" || te.Name == "マス41" || te.Name == "マス50" ||
                       te.Name == "マス59" || te.Name == "マス68" || te.Name == "マス77"
                       )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa5[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa5[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa5[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa5[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa5[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa5[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa5[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa5[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa5[8] += te.Name + "\t"; }
                    }
                    if (
                      te.Name == "マス6" || te.Name == "マス15" || te.Name == "マス24" ||
                      te.Name == "マス33" || te.Name == "マス42" || te.Name == "マス51" ||
                      te.Name == "マス60" || te.Name == "マス69" || te.Name == "マス78"
                      )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa6[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa6[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa6[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa6[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa6[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa6[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa6[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa6[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa6[8] += te.Name + "\t"; }
                    }
                    if (
                   te.Name == "マス7" || te.Name == "マス16" || te.Name == "マス25" ||
                   te.Name == "マス34" || te.Name == "マス43" || te.Name == "マス52" ||
                   te.Name == "マス61" || te.Name == "マス70" || te.Name == "マス79"
                   )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa7[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa7[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa7[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa7[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa7[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa7[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa7[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa7[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa7[8] += te.Name + "\t"; }
                    }
                    if (
                       te.Name == "マス8" || te.Name == "マス17" || te.Name == "マス26" ||
                       te.Name == "マス35" || te.Name == "マス44" || te.Name == "マス53" ||
                       te.Name == "マス62" || te.Name == "マス71" || te.Name == "マス80"
                       )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa8[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa8[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa8[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa8[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa8[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa8[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa8[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa8[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa8[8] += te.Name + "\t"; }
                    }
                    if (
                   te.Name == "マス9" || te.Name == "マス18" || te.Name == "マス27" ||
                   te.Name == "マス36" || te.Name == "マス45" || te.Name == "マス54" ||
                   te.Name == "マス63" || te.Name == "マス72" || te.Name == "マス81"
                   )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarTa9[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarTa9[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarTa9[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarTa9[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarTa9[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarTa9[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarTa9[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarTa9[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarTa9[8] += te.Name + "\t"; }
                    }
                    ////////////////////////マス
                    if (
                  te.Name == "マス1" || te.Name == "マス2" || te.Name == "マス3" ||
                  te.Name == "マス10" || te.Name == "マス11" || te.Name == "マス12" ||
                  te.Name == "マス19" || te.Name == "マス20" || te.Name == "マス21"
                  )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa1[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa1[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa1[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa1[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa1[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa1[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa1[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa1[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa1[8] += te.Name + "\t"; }
                    }
                    if (
               te.Name == "マス4" || te.Name == "マス5" || te.Name == "マス6" ||
               te.Name == "マス13" || te.Name == "マス14" || te.Name == "マス15" ||
               te.Name == "マス22" || te.Name == "マス23" || te.Name == "マス24"
               )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa2[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa2[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa2[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa2[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa2[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa2[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa2[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa2[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa2[8] += te.Name + "\t"; }

                    }

                    if (
               te.Name == "マス7" || te.Name == "マス8" || te.Name == "マス9" ||
               te.Name == "マス16" || te.Name == "マス17" || te.Name == "マス18" ||
               te.Name == "マス25" || te.Name == "マス26" || te.Name == "マス27"
               )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa3[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa3[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa3[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa3[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa3[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa3[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa3[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa3[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa3[8] += te.Name + "\t"; }

                    }
                    if (
               te.Name == "マス28" || te.Name == "マス29" || te.Name == "マス30" ||
               te.Name == "マス37" || te.Name == "マス38" || te.Name == "マス39" ||
               te.Name == "マス46" || te.Name == "マス47" || te.Name == "マス48"
               )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa4[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa4[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa4[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa4[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa4[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa4[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa4[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa4[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa4[8] += te.Name + "\t"; }
                    }
                    if (
           te.Name == "マス31" || te.Name == "マス32" || te.Name == "マス33" ||
           te.Name == "マス40" || te.Name == "マス41" || te.Name == "マス42" ||
           te.Name == "マス49" || te.Name == "マス50" || te.Name == "マス51"
           )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa5[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa5[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa5[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa5[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa5[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa5[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa5[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa5[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa5[8] += te.Name + "\t"; }

                    }
                    if (
                     te.Name == "マス34" || te.Name == "マス35" || te.Name == "マス36" ||
                     te.Name == "マス43" || te.Name == "マス44" || te.Name == "マス45" ||
                     te.Name == "マス52" || te.Name == "マス53" || te.Name == "マス54"
                             )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa6[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa6[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa6[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa6[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa6[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa6[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa6[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa6[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa6[8] += te.Name + "\t"; }
                    }
                    if (
                     te.Name == "マス55" || te.Name == "マス56" || te.Name == "マス57" ||
                     te.Name == "マス64" || te.Name == "マス65" || te.Name == "マス66" ||
                     te.Name == "マス73" || te.Name == "マス74" || te.Name == "マス75"
                             )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa7[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa7[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa7[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa7[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa7[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa7[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa7[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa7[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa7[8] += te.Name + "\t"; }
                    }
                    if (
                     te.Name == "マス58" || te.Name == "マス59" || te.Name == "マス60" ||
                     te.Name == "マス67" || te.Name == "マス68" || te.Name == "マス69" ||
                     te.Name == "マス76" || te.Name == "マス77" || te.Name == "マス78"
                             )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa8[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa8[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa8[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa8[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa8[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa8[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa8[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa8[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa8[8] += te.Name + "\t"; }
                    }
                    if (
                     te.Name == "マス61" || te.Name == "マス62" || te.Name == "マス63" ||
                     te.Name == "マス70" || te.Name == "マス71" || te.Name == "マス72" ||
                     te.Name == "マス79" || te.Name == "マス80" || te.Name == "マス81"
                             )
                    {
                        if (Regex.IsMatch(te.Text, "1")) { textarMa9[0] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "2")) { textarMa9[1] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "3")) { textarMa9[2] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "4")) { textarMa9[3] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "5")) { textarMa9[4] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "6")) { textarMa9[5] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "7")) { textarMa9[6] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "8")) { textarMa9[7] += te.Name + "\t"; }
                        if (Regex.IsMatch(te.Text, "9")) { textarMa9[8] += te.Name + "\t"; }
                    }

                }

            }
            uniqueSub(textarYo1, "1行");
            uniqueSub(textarYo2, "2行");
            uniqueSub(textarYo3, "3行");
            uniqueSub(textarYo4, "4行");
            uniqueSub(textarYo5, "5行");
            uniqueSub(textarYo6, "6行");
            uniqueSub(textarYo7, "7行");
            uniqueSub(textarYo8, "8行");
            uniqueSub(textarYo9, "9行");
            uniqueSub(textarTa1, "1列");
            uniqueSub(textarTa2, "2列");
            uniqueSub(textarTa3, "3列");
            uniqueSub(textarTa4, "4列");
            uniqueSub(textarTa5, "5列");
            uniqueSub(textarTa6, "6列");
            uniqueSub(textarTa7, "7列");
            uniqueSub(textarTa8, "8列");
            uniqueSub(textarTa9, "9列");

            uniqueSub(textarMa1, "1枠：");
            uniqueSub(textarMa2, "2枠：");
            uniqueSub(textarMa3, "3枠：");
            uniqueSub(textarMa4, "4枠：");
            uniqueSub(textarMa5, "5枠：");
            uniqueSub(textarMa6, "6枠：");
            uniqueSub(textarMa7, "7枠：");
            uniqueSub(textarMa8, "8枠：");
            uniqueSub(textarMa9, "9枠：");


        }

        //行　列　枠　でユニークな値をマスにセットする。
        private void uniqueSub(string[] textar, string a)
        {
            int c = textar.Length;
            int l = 0;
            while (c > 0)
            {
                string[] fild = new string[81];
                fild = textar[l].Split('\t');
                if (fild.Length == 2)
                {

                    TextBox atextbox = new TextBox();
                    foreach (TextBox textboxa in panel1.Controls.Find(fild[0], false))
                    {
                        textboxa.Text = (l + 1).ToString(); countnewKakutei++;
                    }


                }
                c--; l++;
            }
        }


        //確定マスの数字を行　列　枠　から除去
        private void delnumTateYokoWaku(string num, string a)
        {

            String aa = a;
            Regex regex = new System.Text.RegularExpressions.Regex(aa);
            Regex regexSP = new System.Text.RegularExpressions.Regex(" ");
            Regex regexName = new System.Text.RegularExpressions.Regex("マス");

            int number = int.Parse(regexName.Replace(num, ""));
            try
            {


                foreach (TextBox ate in this.panel1.Controls)
                {
                    if (ate.ReadOnly != true)
                    {
                        int nameNumber = int.Parse(regexName.Replace(ate.Name, ""));

                        for (int i = 1; i < 82; i += 9)
                        {



                            if (number >= i && number <= i + 8 &&
                                nameNumber >= i && nameNumber <= i + 8 &&
                                nameNumber != number)
                            {
                                ate.Text = regex.Replace(ate.Text, " ");
                            }
                        }



                        for (int i = 0; i < 9; i++)
                        {
                            if (number % 9 == i && nameNumber % 9 == i && nameNumber != number)
                            {
                                ate.Text = regex.Replace(ate.Text, " ");
                            }
                        }


                        for (int i = 1; i <= 9; i += 3)
                        {

                            if (
                                (
                                 number == i | number == i + 1 | number == i + 2 |
                                 number == i + 9 | number == i + 10 | number == i + 11 |
                                 number == i + 18 | number == i + 19 | number == i + 20
                                 ) &&
                                (
                                  nameNumber == i | nameNumber == i + 1 | nameNumber == i + 2 |
                                 nameNumber == i + 9 | nameNumber == i + 10 | nameNumber == i + 11 |
                                 nameNumber == i + 18 | nameNumber == i + 19 | nameNumber == i + 20

                                )
                                && nameNumber != number)
                            {
                                ate.Text = regex.Replace(ate.Text, " ");
                            }

                        }
                        for (int i = 28; i <= 36; i += 3)
                        {

                            if (
                                (
                                 number == i | number == i + 1 | number == i + 2 |
                                 number == i + 9 | number == i + 10 | number == i + 11 |
                                 number == i + 18 | number == i + 19 | number == i + 20
                                 ) &&
                                (
                                  nameNumber == i | nameNumber == i + 1 | nameNumber == i + 2 |
                                 nameNumber == i + 9 | nameNumber == i + 10 | nameNumber == i + 11 |
                                 nameNumber == i + 18 | nameNumber == i + 19 | nameNumber == i + 20

                                )
                                && nameNumber != number)
                            {
                                ate.Text = regex.Replace(ate.Text, " ");
                            }

                        }
                        for (int i = 55; i <= 63; i += 3)
                        {

                            if (
                                (
                                 number == i | number == i + 1 | number == i + 2 |
                                 number == i + 9 | number == i + 10 | number == i + 11 |
                                 number == i + 18 | number == i + 19 | number == i + 20
                                 ) &&
                                (
                                  nameNumber == i | nameNumber == i + 1 | nameNumber == i + 2 |
                                 nameNumber == i + 9 | nameNumber == i + 10 | nameNumber == i + 11 |
                                 nameNumber == i + 18 | nameNumber == i + 19 | nameNumber == i + 20

                                )
                                && nameNumber != number)
                            {
                                ate.Text = regex.Replace(ate.Text, " ");
                            }

                        }


                    }

                }

            }
            catch { }

        }


  
////////////////////////////////////////////////////////////////////////////////
    }
     
}
